' *** SerrxdFast14M2.bas *************************************

' Program demonstrates fast capturing of serial input by
' using indirect addressing and the storage variable area.

' *** Directives ***
  #com 6
  #picaxe 14M2
  #no_data
  #terminal 9600
  
' *** Begin Main Program *************************************
  setfreq m8  
  dirsB = %11111111
  dirsC = %11010111    ' C.3 and C.5 are fixed as inputs 
  disconnect           ' need hard reset for new prog download
  
  wait 1               ' wait for terminal window to open
  sertxd ("Enter text below, and click 'Send'") ' directions
  sertxd (cr,lf,cr,lf) ' move down two lines
  
do
  bptr = 28      	   ' begin storing data at loc 28
  sertxd (">> ")       ' simple prompt
  
bugfix:		
  serrxd [60000,bugfix], @bptrinc  ' see the Primer article
  
' This may look strange, but a loop wouldn't be fast enough.
  serrxd [200], @bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc
	
  @bptr = 0            ' using 0 as end of transmission marker
  bptr = 28            ' reset bptr to the first location
	
  do until @bptr = 0
    sertxd (@bptrinc)  ' echo received data in terminal window
  loop

  sertxd (cr,lf)       ' move down to next line
loop