' *** StorageVarDemo.bas **************************** 2011.07.30 ***

' This program demonstrates one way of using indirect addressing
' and the "storage variable" area of memory in M2-Class processors
' to store and retrieve data.

' *** Directives ***
  #com 6
  #picaxe 14M2
  #no_data
  #terminal 9600
  
' *** Begin Main Program *******************************************

  setfreq m8 
  
  bptr = 28           ' initialize the byte pointer to location 28,
                      ' which is just above the 28 GP variables
                      
  for b0 = 65 to 90
    @bptrinc = b0     ' store each (capitol) letter of the alphabet
  next b0
  
  @bptr = 0           ' we're using 0 as an "end of data" marker
  
  bptr = 28           ' reset the byte pointer to the first location
	
  do until @bptr = 0  ' stop when you get to 0 (and don't output it)
    sertxd (@bptrinc) ' send each char to the terminal window
  loop